var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.launchTizenSimulator=launchTizenSimulator;exports.configureTizenGlobal=exports.buildTizenProject=exports.runTizen=exports.addDevelopTizenCertificate=exports.createDevelopTizenCertificate=exports.configureTizenProject=exports.copyTizenAssets=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _path=_interopRequireDefault(require("path"));var _fs=_interopRequireDefault(require("fs"));var _chalk=_interopRequireDefault(require("chalk"));var _exec=require("../systemTools/exec");var _common=require("../common");var _fileutils=require("../systemTools/fileutils");var _web=require("./web");var configureTizenGlobal=function configureTizenGlobal(c){return new Promise(function(resolve,reject){(0,_common.logTask)('configureTizenGlobal');var tizenAuthorCert=_path.default.join(c.paths.globalConfigFolder,'tizen_author.p12');if(_fs.default.existsSync(tizenAuthorCert)){console.log('tizen_author.p12 file exists!');resolve();}else{console.log('tizen_author.p12 file missing! Creating one for you...');createDevelopTizenCertificate(c).then(function(){return resolve();}).catch(function(e){return reject(e);});}});};exports.configureTizenGlobal=configureTizenGlobal;function launchTizenSimulator(c,name){(0,_common.logTask)("launchTizenSimulator:"+name);if(name){return(0,_exec.execCLI)(c,_common.CLI_TIZEN_EMULATOR,"launch --name "+name);}return Promise.reject('No simulator -t target name specified!');}var copyTizenAssets=function copyTizenAssets(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('copyTizenAssets');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;var sourcePath=_path.default.join(c.paths.appConfigFolder,'assets',platform);var destPath=_path.default.join((0,_common.getAppFolder)(c,platform));(0,_fileutils.copyFolderContentsRecursiveSync)(sourcePath,destPath);resolve();});};exports.copyTizenAssets=copyTizenAssets;var createDevelopTizenCertificate=function createDevelopTizenCertificate(c){return new Promise(function(resolve,reject){(0,_common.logTask)('createDevelopTizenCertificate');(0,_exec.execCLI)(c,_common.CLI_TIZEN,"certificate -- "+c.paths.globalConfigFolder+" -a rnv -f tizen_author -p 1234").then(function(){return addDevelopTizenCertificate(c);}).then(function(){return resolve();}).catch(function(e){(0,_common.logError)(e);resolve();});});};exports.createDevelopTizenCertificate=createDevelopTizenCertificate;var addDevelopTizenCertificate=function addDevelopTizenCertificate(c){return new Promise(function(resolve){(0,_common.logTask)('addDevelopTizenCertificate');(0,_exec.execCLI)(c,_common.CLI_TIZEN,"security-profiles add -n RNVanillaCert -a "+_path.default.join(c.paths.globalConfigFolder,'tizen_author.p12')+" -p 1234").then(function(){return resolve();}).catch(function(e){(0,_common.logError)(e);resolve();});});};exports.addDevelopTizenCertificate=addDevelopTizenCertificate;var getDeviceID=function getDeviceID(c,target){var device,connectResponse,devicesList,lines,devices,deviceID;return _regenerator.default.async(function getDeviceID$(_context){while(1){switch(_context.prev=_context.next){case 0:device=c.program.device;if(!device){_context.next=7;break;}_context.next=4;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_SDB_TIZEN,"connect "+target,_common.logTask));case 4:connectResponse=_context.sent;if(!connectResponse.includes('failed to connect to remote target')){_context.next=7;break;}throw new Error(connectResponse);case 7:_context.next=9;return _regenerator.default.awrap((0,_exec.execCLI)(c,_common.CLI_SDB_TIZEN,'devices',_common.logTask));case 9:devicesList=_context.sent;if(!devicesList.includes(target)){_context.next=16;break;}lines=devicesList.trim().split(/\r?\n/);devices=lines.filter(function(line){return line.includes(target);});if(devices.length>1){}deviceID=devices[0].split('device')[1].trim();return _context.abrupt("return",deviceID);case 16:throw"No device matching "+target+" could be found.";case 17:case"end":return _context.stop();}}});};var runTizen=function runTizen(c,platform,target){return new Promise(function(resolve,reject){(0,_common.logTask)("runTizen:"+platform+":"+target);var platformConfig=c.files.appConfigFile.platforms[platform];var tDir=(0,_common.getAppFolder)(c,platform);var tOut=_path.default.join(tDir,'output');var tBuild=_path.default.join(tDir,'build');var tId=platformConfig.id;var gwt=platformConfig.appName+".wgt";var certProfile=platformConfig.certificateProfile;var deviceID;var TIZEN_UNINSTALL_APP="uninstall -p "+tId+" -t "+deviceID;var TIZEN_INSTALL_APP="install -- "+tOut+" -n "+gwt+" -t "+deviceID;var TIZEN_RUN_APP="run -p "+tId+" -t "+deviceID;configureTizenProject(c,platform).then(function(){return(0,_web.buildWeb)(c,platform);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut,_common.logTask);}).then(function(){return getDeviceID(c,target).then(function(devID){deviceID=devID;});}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"uninstall -p "+tId+" -t "+deviceID,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"install -- "+tOut+" -n "+gwt+" -t "+deviceID,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"run -p "+tId+" -t "+deviceID,_common.logTask);}).then(function(){return resolve();}).catch(function(e){if(e&&e.includes&&e.includes('No device matching')){launchTizenSimulator(c,target).then(function(){(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");resolve();}).catch(reject);}else if(e&&e.includes&&e.includes(TIZEN_UNINSTALL_APP)){(0,_exec.execCLI)(c,_common.CLI_TIZEN,TIZEN_INSTALL_APP,_common.logTask).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,TIZEN_RUN_APP,_common.logTask);}).then(function(){return resolve();}).catch(function(err){(0,_common.logError)(err);(0,_common.logWarning)("Looks like there is no emulator or device connected! Let's try to launch it. \""+_chalk.default.white.bold("rnv target launch -p "+platform+" -t "+target)+"\"");launchTizenSimulator(c,target).then(function(){(0,_common.logInfo)("Once simulator is ready run: \""+_chalk.default.white.bold("rnv run -p "+platform+" -t "+target)+"\" again");resolve();}).catch(reject);});}else{reject(e);}});});};exports.runTizen=runTizen;var buildTizenProject=function buildTizenProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)("buildTizenProject:"+platform);var platformConfig=c.files.appConfigFile.platforms[platform];var tDir=(0,_common.getAppFolder)(c,platform);var tOut=_path.default.join(tDir,'output');var tBuild=_path.default.join(tDir,'build');var certProfile=platformConfig.certificateProfile;configureTizenProject(c,platform).then(function(){return(0,_web.buildWeb)(c,platform);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"build-web -- "+tDir+" -out "+tBuild,_common.logTask);}).then(function(){return(0,_exec.execCLI)(c,_common.CLI_TIZEN,"package -- "+tBuild+" -s "+certProfile+" -t wgt -o "+tOut,_common.logTask);}).then(function(){(0,_common.logSuccess)("Your GWT package is located in "+_chalk.default.white(tOut)+".");return resolve();}).catch(function(e){return reject(e);});});};exports.buildTizenProject=buildTizenProject;var configureTizenProject=function configureTizenProject(c,platform){return new Promise(function(resolve,reject){(0,_common.logTask)('configureTizenProject');if(!(0,_common.isPlatformActive)(c,platform,resolve))return;copyTizenAssets(c,platform).then(function(){return(0,_common.copyBuildsFolder)(c,platform);}).then(function(){return configureProject(c,platform);}).then(function(){return resolve();}).catch(function(e){return reject(e);});});};exports.configureTizenProject=configureTizenProject;var configureProject=function configureProject(c,platform){return new Promise(function(resolve){(0,_common.logTask)("configureProject:"+platform);var appFolder=(0,_common.getAppFolder)(c,platform);var configFile='config.xml';var p=c.files.appConfigFile.platforms[platform];(0,_common.writeCleanFile)(_path.default.join((0,_common.getAppTemplateFolder)(c,platform),configFile),_path.default.join(appFolder,configFile),[{pattern:'{{PACKAGE}}',override:p.package},{pattern:'{{ID}}',override:p.id},{pattern:'{{APP_NAME}}',override:p.appName}]);resolve();});};